Skip to content
Snippets Groups Projects
get-config 10 KiB
Newer Older
  • Learn to ignore specific revisions
  • Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    #!/bin/bash
    
    
    API_BASE_URL=https://labmanager-api.edu-al.unipmn.it/api/1.0
    
    # execute a task and on fail execute it again MAX_RETRY times every RETRY_DELAY seconds
    
    function retry {
        local n=1
        local max=$MAX_RETRY
        local delay=$RETRY_DELAY
        while true; do
            "$@"
            if [[ $? == 0 ]]; then
                break
            else
                if [[ $n -lt $max ]]; then
                    ((n++))
                    echo "Failed. Attempt $n/$max..." >&2
                    sleep $delay;
                else
                    echo "Command failed after $n attempts." >&2
                    exit 1
                fi
            fi
        done
    }
    
    function debug() {
        if [[ "${DEBUG}" == 1 ]]; then
            echo >&2 "$@"
        fi
    }
    
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    function getTokenJSON() {
    
        # store the whole response with the status at the end
        HTTP_RESPONSE=$(curl -s -k -w "HTTPSTATUS:%{http_code}" --max-time 10 -X POST -H "Content-Type: application/json" -d "{\"login\":\"guest\",\"pwd\":\"\"}" ${API_BASE_URL}/login)
    
            debug "Invalid authentication request!"
    
        # extract the status
        HTTP_STATUS=$(echo "$HTTP_RESPONSE" | tr -d '\n' | sed -e 's/.*HTTPSTATUS://')
    
        # check the status
    
            # extract the body
            HTTP_BODY=$(echo "$HTTP_RESPONSE" | sed -e 's/HTTPSTATUS\:.*//g')
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    function jsonValue() {
        KEY=$1
        num=$2
    
        awk -F"[,:}]" '{for(i=1;i<=NF;i++){if($i~/\042'$KEY'\042/){print $(i+1)}}}' | tr -d '"' | sed -n ${num}p
    
        if [[ "$1" == "bootstop" ]]; then
            echo "STOP esame-get-config-boot"
        else
            echo "STOP esame-get-config"
        fi
    
        echo "Authenticating to WS..."
        TOKEN_JSON=`retry getTokenJSON`
        if [[ "$TOKEN_JSON" == "" ]]; then
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
        TOKEN=`echo ${TOKEN_JSON} | jsonValue token 1`
        MACHINE_NAME=`hostname`
    
        echo "Getting machine configuration..."
        MACHINE_JSON=`retry /usr/bin/curl -s -k --max-time 10 -H "Authorization: Bearer ${TOKEN}" -X GET ${API_BASE_URL}/machines/name/${MACHINE_NAME}`
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
        MACHINE_ID=`echo $MACHINE_JSON | jsonValue id 1`
        MACHINE_CONFIGS_ID=`echo $MACHINE_JSON | jsonValue configs_id 1`
    
        CONFIG_NAME=`echo $MACHINE_JSON | jsonValue name 2`
    
            debug "Error fetching machine configuration!"
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
        MACHINE_CONFIGS_ID_PREV=''
    
        CONFIG_NAME_PREV=''
        if [[ -e /local/config_name ]]
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
        then
    
            CONFIG_NAME_PREV=`cat /local/config_name`
    
        if [[ "${MACHINE_ID}" == "" ]]; then
            echo "Error downloading config file (machine_id empty, maybe it is not in LabManager's DB)"
            return 1
        fi
        HTTP_STATUS=`retry /usr/bin/curl -s -k -w "%{http_code}" -o /local/esame-machine.conf --max-time 10 --header "Authorization: Bearer ${TOKEN}" -X GET ${API_BASE_URL}/machines/${MACHINE_ID}/configfile`
    
        if [[ $HTTP_STATUS -ne 200 ]]
        then
            echo "Error downloading config file (http_status=$HTTP_STATUS)"
    
        else
            echo "Downloaded config file (http_status=$HTTP_STATUS)"
        fi
    
        echo "Downloading machine iptables config file..."
    
        HTTP_STATUS=`retry /usr/bin/curl -s -k -w "%{http_code}" -o /local/iptables --max-time 10 --header "Authorization: Bearer ${TOKEN}" -X GET ${API_BASE_URL}/machines/${MACHINE_ID}/ipconfigfile`
    
        if [[ $HTTP_STATUS -ne 200 ]]
        then
            echo "Error downloading iptables config file (http_status=$HTTP_STATUS)"
    
        else
            echo "Downloaded iptables config file (http_status=$HTTP_STATUS)"
        fi
    
    }
    
    
    updateCurrentConfigId() {
        # Update this machine's current config id
        HTTP_STATUS=`/usr/bin/curl -s -k -w "%{http_code}" -o /dev/null --max-time 10 -H "Content-Type: application/json" -H "Authorization: Bearer ${TOKEN}" \
            -X PUT -d "{\"current_configs_id\":\"$MACHINE_CONFIGS_ID\"}" ${API_BASE_URL}/machines/${MACHINE_ID}/currentconfig`
    
        if [[ $HTTP_STATUS -ne 200 ]]
        then
            echo "Error updating current config (http_status=$HTTP_STATUS)"
            exit 1
        else
            echo "Updated current config (http_status=$HTTP_STATUS)"
        fi
    }
    
    
        cp -f /local/esame-machine.conf /local/esame-machine.conf.prev >/dev/null 2>&1
        cp -f /local/iptables /local/iptables.prev >/dev/null 2>&1
    
            debug "Error fetching machine config file!"
    
            debug "Error fetching machine iptables file!"
    
            echo "START esame-get-config-boot"
        else
            echo "START esame-get-config"
        fi
    
    
        getConfig
        RESULT=$?
    
        #echo "TOKEN_JSON: $TOKEN_JSON"
        #echo "TOKEN: $TOKEN"
        #echo "MACHINE_NAME: $MACHINE_NAME"
        #echo "MACHINE_JSON: $MACHINE_JSON"
        #echo "MACHINE_ID: $MACHINE_ID"
        #echo "MACHINE_CONFIGS_ID: $MACHINE_CONFIGS_ID"
        #echo "MACHINE_CONFIGS_ID_PREV: $MACHINE_CONFIGS_ID_PREV"
        if [[ -n "$CONFIG_NAME" ]]; then
            echo "Configuration: $CONFIG_NAME"
    
                echo "Fatal error(s): aborting esame and switching machine to normal state..."
    
                # reset and remove exam configuration files
                echo "$NORMAL_CONFIG_NAME" > /local/config_name
                rm /local/esame-machine.conf >/dev/null 2>&1
                rm /local/esame-machine.conf.prev >/dev/null 2>&1
                rm /local/iptables >/dev/null 2>&1
                rm /local/iptables.prev >/dev/null 2>&1
    
                /usr/bin/systemctl isolate graphical && exit 0
    
            echo "Fatal error(s): missing or wrong web service reply, abort."
            exit 1
    
    
        # configuration profile is changed
    
        if [[ "$CONFIG_NAME" != "$CONFIG_NAME_PREV" ]]
    
            echo "${CONFIG_NAME}" > /local/config_name
    
            # no exam, set normal target
    
            if [[ "$CONFIG_NAME" == "$NORMAL_CONFIG_NAME" ]]
    
            then
                # stop some services to revert system files
    
                rm /local/esame-machine.conf >/dev/null 2>&1
                rm /local/esame-machine.conf.prev >/dev/null 2>&1
                rm /local/iptables >/dev/null 2>&1
                rm /local/iptables.prev >/dev/null 2>&1
    
    	    echo "Normal!"
                #systemctl isolate graphical && exit 0
                /usr/bin/systemctl reboot
                #--force
    
                /usr/bin/systemctl reboot
                #--force
    
            # at boot time choose the correct target
    
                # we have just rebooted, update the current configuration via web service
                updateCurrentConfigId
                case "$CONFIG_NAME" in
    
                        ;;
                    'kiosk-dir' | 'kiosk-dir-esami' | 'kiosk-escher' | 'kiosk-freebrowsing' | 'kiosk-teco') # kiosk mode
    
                    'show') # show mode, an exam mode with no limitations on USB ports and network
    
        if [[ "$CONFIG_NAME" != "$NORMAL_CONFIG_NAME" ]]
    
        then
            # check if parameters are changed
            cmp --silent /local/esame-machine.conf /local/esame-machine.conf.prev
            if [[ $? -ne 0 ]]
            then
                /usr/bin/systemctl daemon-reload
                echo "Configuration parameters changed: restart some services... "
                # restart some exam services
    
                #echo -n "USB..."
                #/usr/bin/systemctl restart esame-usb
                #echo " done."
                KIOSK_URL_CHANGED=$(diff /local/esame-machine.conf /local/esame-machine.conf.prev  | grep ESAME_KIOSK_URL -c)
                if [[ $KIOSK_URL_CHANGED -ne 0 ]]
    
                    echo -n "Firefox Home..."
                    FIREFOX_PID=$(pgrep firefox)
                    if [[ "${FIREFOX_PID}" != "" ]]
                    then
                        FIREFOX_USER=$(ps -o user= -p ${FIREFOX_PID})
                        rm -f /local/${FIREFOX_USER}/.mozilla/firefox/44bu2eyb.default/lock
                        pkill firefox
                        sleep 2
                        /usr/bin/systemctl restart esame-firefox-home
                        echo " done."
                        # no way to restart firefox, I must miss something :(
                        #echo -n "Restarting Firefox..."
                        #su - ${FIREFOX_USER} -c 'nohup /usr/bin/firefox --display=:0.0 &'
                        #echo " done."
                    else
                        /usr/bin/systemctl restart esame-firefox-home
                        echo " done."
                    fi
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    }
    
    
    args=("$@")
    
    case "$1" in
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    'start')
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    'stop')
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    'restart')
    
        echo "Usage: $0 { bootstart | bootstop | start | stop | restart }";
    
    Alberto LIVIO BECCARIA's avatar
    Alberto LIVIO BECCARIA committed
    esac
    exit 0